from __future__ import absolute_import
from __future__ import division
from __future__ import print_function
from __future__ import unicode_literals

import cv2 as cv
import vot
import sys
import numpy as np
from lib.test.tracker.mixformer_vit_online import MixFormerOnline
import lib.test.parameter.mixformer_vit_online as vot_params
import vot2022.vot as vot

class Tracker(object):

    def __init__(self, tracker):
        self.tracker = tracker
        # self.tracker.initialize(image, info)

    def initialize(self, image, box):
        self.H, self.W, _ = image.shape
        #gt_bbox_np = np.array(region).astype(np.float32)
        '''Initialize STARK for specific video'''
        #init_info = {'init_bbox': list(gt_bbox_np)}
        init_info = {'init_bbox': box}
        self.tracker.initialize(image, init_info)

    def track(self, image):
        outputs = self.tracker.track(image)
        pred_bbox = outputs['target_bbox']
        #conf_score = outputs["conf_score"]
        #return pred_bbox, conf_score
        return pred_bbox, 1

params = vot_params.parameters("baseline_large_score", model="MixFormer-score-large24_384_ep0285.pth.tar")
mixformer = MixFormerOnline(params, "VOT22STB")
tracker = Tracker(mixformer)
handle = vot.VOT("rectangle")
selection = handle.region()
imagefile = handle.frame()
init_box = [selection.x, selection.y, selection.width, selection.height]

if not imagefile:
    sys.exit(0)

image = cv.cvtColor(cv.imread(imagefile), cv.COLOR_BGR2RGB)

tracker.initialize(image, init_box)

while True:
    imagefile = handle.frame()

    if not imagefile:
        break

    image = cv.cvtColor(cv.imread(imagefile), cv.COLOR_BGR2RGB)
    b1, conf = tracker.track(image)
    x1, y1, w, h = b1
    handle.report(vot.Rectangle(x1, y1, w, h), conf)

